/*
* Imaginet Compiler 3.3.480
* Copyright © 2020- Imagimob AB, All Rights Reserved.
* 
* Generated at 2022-10-21 10:28:05 UTC. Any changes will be lost.
* 
* Memory    Size                      Efficiency
* Buffers   4656 bytes (RAM)          73 %
* State     1984 bytes (RAM)          100 %
* Readonly  3548 bytes (Flash)        100 %
* 
* Layer                          Shape           Type       Function
* Sliding Window (data points)   [64,6]          float      dequeue
*    window_shape = [64,6]
*    stride = 60
*    buffer_multiplier = 1
* Hann smoothing                 [64,6]          float      dequeue
*    sym = True
* Real Discrete Fourier Transform [33,6,2]        float      dequeue
*    axis = 1
* Frobenius norm                 [33,6]          float      dequeue
*    axis = 0
* Batch Normalization            [33,6]          float      dequeue
*    epsilon = 0.001
*    axis = 2
*    gamma = float[6]
*    beta = float[6]
*    mean = float[6]
*    variance = float[6]
* Convolution 1D                 [33,8]          float      dequeue
*    filters = 8
*    kernel_size = 3
*    dilation_rate = 1
*    strides = 1
*    padding = same
*    activation = linear
*    use_bias = False
*    weight = float[3,6,8]
* Batch Normalization            [33,8]          float      dequeue
*    epsilon = 0.001
*    axis = 2
*    gamma = float[8]
*    beta = float[8]
*    mean = float[8]
*    variance = float[8]
* Activation                     [33,8]          float      dequeue
*    activation = relu
* Convolution 1D                 [33,4]          float      dequeue
*    filters = 4
*    kernel_size = 3
*    dilation_rate = 1
*    strides = 1
*    padding = same
*    activation = linear
*    use_bias = False
*    weight = float[3,8,4]
* Batch Normalization            [33,4]          float      dequeue
*    epsilon = 0.001
*    axis = 2
*    gamma = float[4]
*    beta = float[4]
*    mean = float[4]
*    variance = float[4]
* Activation                     [33,4]          float      dequeue
*    activation = relu
* Max pooling 1D                 [31,4]          float      dequeue
*    pool_size = 3
*    strides = 1
*    padding = valid
* Long Short-Term Memory         [31,1,4]        float      dequeue
*    units = 4
*    activation = tanh
*    recurrent_activation = sigmoid
*    use_bias = True
*    return_sequences = True
*    return_state = False
*    stateful = False
*    go_backwards = False
*    kernel = float[4,16]
*    recurrent_kernel = float[4,16]
*    bias = float[16]
* Long Short-Term Memory         [1,4]           float      dequeue
*    units = 4
*    activation = tanh
*    recurrent_activation = sigmoid
*    use_bias = True
*    return_sequences = False
*    return_state = False
*    stateful = False
*    go_backwards = False
*    kernel = float[4,16]
*    recurrent_kernel = float[4,16]
*    bias = float[16]
* Dropout                        [1,4]           float      dequeue
*    rate = 0.1
* Dense                          [18]            float      dequeue
*    units = 18
*    use_bias = False
*    activation = linear
*    weight = float[4,18]
* Batch Normalization            [18]            float      dequeue
*    epsilon = 0.001
*    axis = 1
*    gamma = float[18]
*    beta = float[18]
*    mean = float[18]
*    variance = float[18]
* Activation                     [18]            float      dequeue
*    activation = relu
* Dense                          [9]             float      dequeue
*    units = 9
*    use_bias = False
*    activation = linear
*    weight = float[18,9]
* Batch Normalization            [9]             float      dequeue
*    epsilon = 0.001
*    axis = 1
*    gamma = float[9]
*    beta = float[9]
*    mean = float[9]
*    variance = float[9]
* Activation                     [9]             float      dequeue
*    activation = relu
* Dense                          [5]             float      dequeue
*    units = 5
*    use_bias = False
*    activation = linear
*    weight = float[9,5]
* Batch Normalization            [5]             float      dequeue
*    epsilon = 0.001
*    axis = 1
*    gamma = float[5]
*    beta = float[5]
*    mean = float[5]
*    variance = float[5]
* Dense                          [1]             float      dequeue
*    units = 1
*    use_bias = True
*    activation = linear
*    weight = float[5,1]
*    bias = float[1]
* 
* Exported functions:
* 
* int IMAI_dequeue(float *restrict data_out)
*    Description: Dequeue features. RET_SUCCESS (0) on success, RET_NODATA (-1) if no data is available, RET_NOMEM (-2) on internal memory error
*    Parameter data_out is Output of size float[1].
* 
* int IMAI_enqueue(const float *restrict data_in)
*    Description: Enqueue features. Returns SUCCESS (0) on success, else RET_NOMEM (-2) when low on memory.
*    Parameter data_in is Input of size float[6].
* 
* void IMAI_init(void)
*    Description: Initializes buffers to initial state. This function also works as a reset function.
* 
* 
* Disclaimer:
*   The generated code relies on the optimizations done by the C compiler.
*   For example many for-loops of length 1 must be removed by the optimizer.
*   This can only be done if the functions are inlined and simplified.
*   Check disassembly if unsure.
*   tl;dr Compile using gcc with -O3 or -Ofast
*/

#ifndef _IMAI_MODEL_H_
#define _IMAI_MODEL_H_
#ifdef _MSC_VER
#pragma once
#endif

#include <stdint.h>
#define IMAI_API_QUEUE

// First nibble is bit encoding, second nibble is number of bytes
#define IMAGINET_TYPES_NONE	(0x0)
#define IMAGINET_TYPES_FLOAT32	(0x14)
#define IMAGINET_TYPES_FLOAT64	(0x18)
#define IMAGINET_TYPES_INT8	(0x21)
#define IMAGINET_TYPES_INT16	(0x22)
#define IMAGINET_TYPES_INT32	(0x24)
#define IMAGINET_TYPES_INT64	(0x28)
#define IMAGINET_TYPES_QDYN8	(0x31)
#define IMAGINET_TYPES_QDYN16	(0x32)
#define IMAGINET_TYPES_QDYN32	(0x34)

// data_in [6] (24 bytes)
#define IMAI_DATA_IN_COUNT (6)
#define IMAI_DATA_IN_TYPE float
#define IMAI_DATA_IN_TYPE_ID IMAGINET_TYPES_FLOAT32
#define IMAI_DATA_IN_SCALE (1)
#define IMAI_DATA_IN_OFFSET (0)
#define IMAI_DATA_IN_IS_QUANTIZED (0)

// data_out [1] (4 bytes)
#define IMAI_DATA_OUT_COUNT (1)
#define IMAI_DATA_OUT_TYPE float
#define IMAI_DATA_OUT_TYPE_ID IMAGINET_TYPES_FLOAT32
#define IMAI_DATA_OUT_SCALE (1)
#define IMAI_DATA_OUT_OFFSET (0)
#define IMAI_DATA_OUT_IS_QUANTIZED (0)

#define IMAI_KEY_MAX (147)



// Return codes
#define IMAI_RET_SUCCESS 0
#define IMAI_RET_NODATA -1
#define IMAI_RET_NOMEM -2

// Exported methods
int IMAI_dequeue(float *restrict data_out);
int IMAI_enqueue(const float *restrict data_in);
void IMAI_init(void);

#endif /* _IMAI_MODEL_H_ */
